/*
 * @Author: wjc
 * @Date: 2024-06-05 17:13:30
 * @LastEditors: wjc
 * @LastEditTime: 2024-06-12 17:08:53
 * @Description:
 */
import { defineStore } from 'pinia'

import { UserState, ILogin, LoginRes, Employees } from '@/models/userTypes'
import { login, getUserInfo } from '@/api/userApi'

export const useUserStore = defineStore('user', {
  state: (): UserState => {
    return {
      isDialogShowed: false,
      isInstall: false,
      token: '',
      userInfo: new Employees({}),
    }
  },
  actions: {
    loginAction(data: ILogin): Promise<LoginRes> {
      return new Promise((resolve, reject) => {
        login(data)
          .then((res) => {
            if (res && res.data) {
              this.isDialogShowed = true
              this.isInstall = true
              uni.setStorageSync('storage-loginInfo', data)
              uni.setStorageSync('storage-user-id', res.data.id)
              resolve(res.data)
            }
          })
          .catch((error) => {
            reject(error)
          })
      })
    },
    getUserInfoAction(): Promise<Employees> {
      return new Promise((resolve, reject) => {
        const id = uni.getStorageSync('storage-user-id')
        if (id) {
          getUserInfo(id)
            .then((res) => {
              if (res && res.data) {
                this.userInfo = res.data
                resolve(res.data)
              }
            })
            .catch((error) => {
              reject(error)
            })
        }
      })
    },
  },
})
